Bug 28720 - Update the process of adding a checkout note in the OPAC
Summary: Update the process of adding a checkout note in the OPAC
Status: RESOLVED FIXED
Alias: None
Product: Koha
Classification: Unclassified
Component: OPAC (show other bugs)
Version: master
Hardware: All All
: P5 - low enhancement (vote)
Assignee: Owen Leonard
QA Contact: Testopia
URL:
Keywords: Manual
Depends on:
Blocks:
 
Reported: 2021-07-16 19:48 UTC by Owen Leonard
Modified: 2021-10-08 14:26 UTC (History)
3 users (show)

See Also:
Change sponsored?: ---
Patch complexity: Small patch
Text to go in the release notes:
This enhancement moves the entry of checkout notes for the OPAC into a modal window, with the goal of making note entry easier. The "add note" button in the report a problem on the OPAC summary page will trigger a modal where a patron can submit or edit their message: - The modal window contains text explaining that the note will be shown to staff when the item is checked in. - The message about a successfully submitted message has text formatting added to improve clarity, and includes an edit link for changing a message.
Version(s) released in:
21.11.00


Attachments
Screenshot of checkout note modal (33.00 KB, image/png)
2021-07-16 19:48 UTC, Owen Leonard
Details
Screenshot of updated checkout note confirmation (25.83 KB, image/png)
2021-07-16 19:49 UTC, Owen Leonard
Details
Bug 28720: Update the process of adding a checkout note in the OPAC (14.70 KB, patch)
2021-07-26 15:47 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 28720: Update the process of adding a checkout note in the OPAC (14.75 KB, patch)
2021-07-26 20:29 UTC, David Nind
Details | Diff | Splinter Review
Bug 28720: (follow-up) Improve string translation (10.73 KB, patch)
2021-08-19 12:17 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 28720: (follow-up) Improve string translation (10.77 KB, patch)
2021-09-07 19:49 UTC, David Nind
Details | Diff | Splinter Review
Bug 28720: Update the process of adding a checkout note in the OPAC (14.81 KB, patch)
2021-10-03 14:28 UTC, Katrin Fischer
Details | Diff | Splinter Review
Bug 28720: (follow-up) Improve string translation (10.84 KB, patch)
2021-10-03 14:28 UTC, Katrin Fischer
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Owen Leonard 2021-07-16 19:48:57 UTC
Created attachment 122925 [details]
Screenshot of checkout note modal

I'd like to make some changes to the way checkout notes are submitted in the OPAC:

- The "add note" button will trigger a modal where the user can submit or edit their message.
- The modal window will contain text explaining that the note will be shown to staff when the item is checked in.
- The message about a successfully submitted message will have text formatting added to improve clarity, and include an edit link for re-editing a message.
Comment 1 Owen Leonard 2021-07-16 19:49:29 UTC
Created attachment 122926 [details]
Screenshot of updated checkout note confirmation
Comment 2 Owen Leonard 2021-07-26 15:47:41 UTC Comment hidden (obsolete)
Comment 3 David Nind 2021-07-26 20:29:23 UTC
Created attachment 123201 [details] [review]
Bug 28720: Update the process of adding a checkout note in the OPAC

This patch moves the entry of checkout notes into a modal window with
the goal of making note entry easier.

To test, apply the patch and make sure the AllowCheckoutNotes system
preference is enabled.

- Log in to the OPAC as a user with checkouts.
- On the "Your summary" page, confirm that the table listing your
  checkouts has a "Report a problem" column with "Add note" buttons.
- Click an "Add note" button. A modal window should be shown which
  includes the title of the item, a textarea for writing a note, and a
  hint, "Your note will be shown to the librarian when the item is
  checked in."
- Add a note and submit it.
- The modal should close and a note at the top of the page should tell
  you your note has been saved. The contents of your note should be
  shown below that along with an "Edit note" link.
  - Confirm that the "Edit note" link works as expected.
  - Confirm that the "Add note" button you clicked in the table of
    checkouts now reads "Edit note."
    - You should be able to click this button and edit your note.
- Confirm that each note button works to add a note to the correct
  title.
- Confirm that the "Renew selected" and "Renew all" controls work.

Signed-off-by: David Nind <david@davidnind.com>
Comment 4 Katrin Fischer 2021-08-18 09:11:33 UTC
Hm, I have a few issues and concerns here:

1) I think I'd like to have the note show in the column once it was added. At the moment it's easy to miss it, as you have to click on "Edit note" first to see it.

2) We have export functionality on this table now (I think after this patch was initially written) and instead of the notes we see "Add note" or "Edit note" in the column.

3) I am a little worried if translation tools will pick up on this construct:

        [% IF ( ISSUE.note ) -%]
+                                                           [% SET note_action = "Edit note" %]
+                                                        [% ELSE -%]
+                                                           [% SET note_action = "Add note" %]
+                                                        [% END %]
Comment 5 Owen Leonard 2021-08-19 12:17:47 UTC Comment hidden (obsolete)
Comment 6 David Nind 2021-09-07 19:49:41 UTC
Created attachment 124631 [details] [review]
Bug 28720: (follow-up) Improve string translation

This patch fixes the following issues raised by QA:

- It modifies the markup so that "Add note" and "Edit note" can be
  translated more easily.
- It adds display of existing notes back to the table of checkouts.
- It adds to the table configuration so that a "plain" view of the notes
  (without buttons) is shown in print view and in CSV export.
- It improves handling of notes containing quotation marks which would
  previously have broken some edit interactions.

Signed-off-by: David Nind <david@davidnind.com>
Comment 7 Katrin Fischer 2021-10-03 14:28:01 UTC
Created attachment 125681 [details] [review]
Bug 28720: Update the process of adding a checkout note in the OPAC

This patch moves the entry of checkout notes into a modal window with
the goal of making note entry easier.

To test, apply the patch and make sure the AllowCheckoutNotes system
preference is enabled.

- Log in to the OPAC as a user with checkouts.
- On the "Your summary" page, confirm that the table listing your
  checkouts has a "Report a problem" column with "Add note" buttons.
- Click an "Add note" button. A modal window should be shown which
  includes the title of the item, a textarea for writing a note, and a
  hint, "Your note will be shown to the librarian when the item is
  checked in."
- Add a note and submit it.
- The modal should close and a note at the top of the page should tell
  you your note has been saved. The contents of your note should be
  shown below that along with an "Edit note" link.
  - Confirm that the "Edit note" link works as expected.
  - Confirm that the "Add note" button you clicked in the table of
    checkouts now reads "Edit note."
    - You should be able to click this button and edit your note.
- Confirm that each note button works to add a note to the correct
  title.
- Confirm that the "Renew selected" and "Renew all" controls work.

Signed-off-by: David Nind <david@davidnind.com>

Signed-off-by: Katrin Fischer <katrin.fischer.83@web.de>
Comment 8 Katrin Fischer 2021-10-03 14:28:06 UTC
Created attachment 125682 [details] [review]
Bug 28720: (follow-up) Improve string translation

This patch fixes the following issues raised by QA:

- It modifies the markup so that "Add note" and "Edit note" can be
  translated more easily.
- It adds display of existing notes back to the table of checkouts.
- It adds to the table configuration so that a "plain" view of the notes
  (without buttons) is shown in print view and in CSV export.
- It improves handling of notes containing quotation marks which would
  previously have broken some edit interactions.

Signed-off-by: David Nind <david@davidnind.com>

Signed-off-by: Katrin Fischer <katrin.fischer.83@web.de>
Comment 9 Jonathan Druart 2021-10-04 13:20:26 UTC
Shouldn't the input in the modal have the focus?
Comment 10 Jonathan Druart 2021-10-06 08:37:36 UTC
Pushed to master for 21.11, thanks to everybody involved!